diff --git a/test/validation/Makefile.am b/test/validation/Makefile.am
index 0b831d0..4bee2ab 100644
--- a/test/validation/Makefile.am
+++ b/test/validation/Makefile.am
@@ -6,11 +6,13 @@ AM_LDFLAGS += -L$(CUNIT_PATH)/lib -static -lcunit
 if ODP_CUNIT_ENABLED
 TESTS = ${bin_PROGRAMS}
 check_PROGRAMS = ${bin_PROGRAMS}
-bin_PROGRAMS = odp_init odp_queue odp_crypto
+bin_PROGRAMS = odp_init odp_queue odp_crypto odp_shm
 odp_init_LDFLAGS = $(AM_LDFLAGS)
 odp_queue_LDFLAGS = $(AM_LDFLAGS)
 odp_crypto_CFLAGS = $(AM_CFLAGS) -I$(srcdir)/crypto
 odp_crypto_LDFLAGS = $(AM_LDFLAGS)
+odp_shm_CFLAGS = $(AM_CFLAGS) -I$(srcdir)/common
+odp_shm_LDFLAGS = $(AM_LDFLAGS)
 endif
 
 dist_odp_init_SOURCES = odp_init.c
@@ -18,3 +20,4 @@ dist_odp_queue_SOURCES = odp_queue.c
 dist_odp_crypto_SOURCES = crypto/odp_crypto_test_async_inp.c \
 			  crypto/odp_crypto_test_sync_inp.c \
 			  odp_crypto.c
+dist_odp_shm_SOURCES = odp_shm.c common/odp_cunit_common.c
diff --git a/test/validation/common/odp_cunit_common.c b/test/validation/common/odp_cunit_common.c
new file mode 100644
index 0000000..885b981
--- /dev/null
+++ b/test/validation/common/odp_cunit_common.c
@@ -0,0 +1,37 @@
+/* Copyright (c) 2014, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+/**
+ * @file
+ *
+ * ODP test application common
+ */
+
+#include <string.h>
+#include <odp.h>
+#include "odp_cunit_common.h"
+#include "odph_linux.h"
+/* Globals */
+static odph_linux_pthread_t thread_tbl[MAX_WORKERS];
+
+/** create test thread */
+int odp_cunit_thread_create(void *func_ptr(void *), pthrd_arg *arg)
+{
+	/* Create and init additional threads */
+	odph_linux_pthread_create(thread_tbl, arg->numthrds, 0, func_ptr,
+				  (void *)arg);
+
+	return 0;
+}
+
+/** exit from test thread */
+int odp_cunit_thread_exit(pthrd_arg *arg)
+{
+	/* Wait for other threads to exit */
+	odph_linux_pthread_join(thread_tbl, arg->numthrds);
+
+	return 0;
+}
diff --git a/test/validation/common/odp_cunit_common.h b/test/validation/common/odp_cunit_common.h
new file mode 100644
index 0000000..5eec376
--- /dev/null
+++ b/test/validation/common/odp_cunit_common.h
@@ -0,0 +1,35 @@
+/* Copyright (c) 2014, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+/**
+ * @file
+ *
+ * ODP test application common headers
+ */
+
+#ifndef ODP_CUNICT_COMMON_H
+#define ODP_CUNICT_COMMON_H
+
+#define MAX_WORKERS 32 /**< Maximum number of work threads */
+
+typedef struct {
+	uint32_t foo;
+	uint32_t bar;
+} test_shared_data_t;
+
+/**
+ * Thread argument
+ */
+typedef struct {
+	int testcase; /**< specifies which set of API's to exercise */
+	int numthrds; /**< no of pthreads to create */
+} pthrd_arg;
+
+/** create thread fro start_routine function */
+extern int odp_cunit_thread_create(void *func_ptr(void *), pthrd_arg *arg);
+extern int odp_cunit_thread_exit(pthrd_arg *);
+
+#endif /* ODP_COMMON_H */
diff --git a/test/validation/odp_shm.c b/test/validation/odp_shm.c
new file mode 100644
index 0000000..be2b52b
--- /dev/null
+++ b/test/validation/odp_shm.c
@@ -0,0 +1,124 @@
+/* Copyright (c) 2014, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include "odp.h"
+#include "CUnit/Basic.h"
+#include "odp_cunit_common.h"
+
+#define ALIGE_SIZE  (128)
+#define TESTNAME "cunit_test_shared_data"
+#define TEST_SHARE_FOO (0xf0f0f0f0)
+#define TEST_SHARE_BAR (0xf0f0f0f)
+
+static void *run_shm_thread(void *arg)
+{
+	odp_shm_info_t  info;
+	odp_shm_t shm;
+	test_shared_data_t *test_shared_data;
+	int thr;
+
+	thr = odp_thread_id();
+	printf("Thread %i starts\n", thr);
+
+	shm = odp_shm_lookup(TESTNAME);
+	CU_ASSERT(ODP_SHM_INVALID != shm);
+	test_shared_data = odp_shm_addr(shm);
+	CU_ASSERT(TEST_SHARE_FOO == test_shared_data->foo);
+	CU_ASSERT(TEST_SHARE_BAR == test_shared_data->bar);
+	CU_ASSERT(0 == odp_shm_info(shm, &info));
+	CU_ASSERT(0 == strcmp(TESTNAME, info.name));
+	CU_ASSERT(0 == info.flags);
+	CU_ASSERT(test_shared_data == info.addr);
+	CU_ASSERT(sizeof(test_shared_data_t) <= info.size);
+	CU_ASSERT(odp_sys_page_size() == info.page_size);
+	odp_shm_print_all();
+
+	fflush(stdout);
+	return arg;
+}
+
+static void test_odp_shm_sunnyday(void)
+{
+	pthrd_arg thrdarg;
+	odp_shm_t shm;
+	test_shared_data_t *test_shared_data;
+
+	shm = odp_shm_reserve(TESTNAME,
+			      sizeof(test_shared_data_t), ALIGE_SIZE, 0);
+	CU_ASSERT(ODP_SHM_INVALID != shm);
+
+	CU_ASSERT(0 == odp_shm_free(shm));
+	CU_ASSERT(ODP_SHM_INVALID == odp_shm_lookup(TESTNAME));
+
+	shm = odp_shm_reserve(TESTNAME,
+			      sizeof(test_shared_data_t), ALIGE_SIZE, 0);
+	CU_ASSERT(ODP_SHM_INVALID != shm);
+
+	test_shared_data = odp_shm_addr(shm);
+	CU_ASSERT(NULL != test_shared_data);
+	test_shared_data->foo = TEST_SHARE_FOO;
+	test_shared_data->bar = TEST_SHARE_BAR;
+
+	thrdarg.numthrds = odp_sys_core_count();
+
+	if (thrdarg.numthrds > MAX_WORKERS)
+		thrdarg.numthrds = MAX_WORKERS;
+
+	odp_cunit_thread_create(run_shm_thread, &thrdarg);
+	odp_cunit_thread_exit(&thrdarg);
+}
+
+static int finalize(void)
+{
+	odp_term_local();
+	odp_term_global();
+	return 0;
+}
+
+static int init(void)
+{
+	printf("\tODP API version: %s\n", odp_version_api_str());
+	printf("\tODP implementation version: %s\n", odp_version_impl_str());
+	return 0;
+}
+
+CU_TestInfo test_odp_shm[] = {
+	{"test_odp_shm_creat",  test_odp_shm_sunnyday},
+	CU_TEST_INFO_NULL,
+};
+
+CU_SuiteInfo suites[] = {
+	{"odp_system", init, finalize, NULL, NULL, test_odp_shm},
+	CU_SUITE_INFO_NULL,
+};
+
+
+int main(void)
+{
+	int ret;
+
+	if (0 != odp_init_global(NULL, NULL)) {
+		printf("odp_init_global fail.\n");
+		return -1;
+	}
+	if (0 != odp_init_local()) {
+		printf("odp_init_local fail.\n");
+		return -1;
+	}
+
+	CU_set_error_action(CUEA_ABORT);
+
+	CU_initialize_registry();
+	CU_register_suites(suites);
+	CU_basic_set_mode(CU_BRM_VERBOSE);
+	CU_basic_run_tests();
+
+	ret = CU_get_number_of_failure_records();
+
+	CU_cleanup_registry();
+
+	return ret;
+}